//
// Created by Falko Alrik Schmidt on 11.01.24.
//

#include "Ulm_AS7331.h"

Ulm_AS7331::Ulm_AS7331() : SfeAS7331ArdI2C() {
    // Nothing more to do here.
}

bool Ulm_AS7331::begin() {

    if(!SfeAS7331ArdI2C::begin()) {
        return false;
    }

    return this->prepareMeasurement(MEAS_MODE_CMD);
}

bool Ulm_AS7331::sample(Ulm_AS7331_Sample &sample) {

    bool success = this->setStartState(true) == kSTkErrOk;
    success &= (this->readAll() == kSTkErrOk);

    sample.temperature = this->getTemp();
    sample.uva = this->getUVA();
    sample.uvb = this->getUVB();
    sample.uvc = this->getUVC();

    return success;
}
