//
// Created by Falko Alrik Schmidt on 19.09.23.
//

#ifndef UULM_WEATHERBALOON_ARDUINO_FRAMEWORK_TEST_ULM_TEMPERATURESENSOR_DS18B20_H
#define UULM_WEATHERBALOON_ARDUINO_FRAMEWORK_TEST_ULM_TEMPERATURESENSOR_DS18B20_H


#include "DallasTemperature.h"
#include "Ulm_GenericSensor.h"

/**
 * This class represents temperature sensors of type DS18B20.
 *
 * @author Falko Schmidt
 * @since 1.0
 */
class Ulm_DS18B20 : DallasTemperature, public Ulm_GenericSensor<float> {

private:
    /**
     * The OneWire interface handle, that is used to communicate
     * with the temperature sensor of type 'DS18B20'.
     */
    OneWire oneWire;

public:
    /**
     * Constructor.
     * @param pin the pin, which the sensor is connected to.
     */
    explicit Ulm_DS18B20(uint8_t pin);

    /**
     * Initializes the temperature sensor.
     * @return {@code true} if everything is successful and exactly
     * one temperature sensor is found, {@code false} otherwise.
     */
    bool begin() override;

    /**
     * Reads out the temperature from sensor.
     * @return {@code true} on success, {@code false} if there is an
     * error with the sample or sensor.
     */
    bool sample(float &t) override;
};


#endif //UULM_WEATHERBALOON_ARDUINO_FRAMEWORK_TEST_ULM_TEMPERATURESENSOR_DS18B20_H
