//
// Created by Falko Alrik Schmidt on 09.03.24.
//

#ifndef ULM_WEATHERBALLOON_ULM_LSM6SDL_H
#define ULM_WEATHERBALLOON_ULM_LSM6SDL_H

#include "FastIMU.h"

#include "Ulm_Beginnable.h"
#include "Ulm_GenericSensor.h"

struct Ulm_LSM6SDL_Sample {
    float accelerationX, accelerationY, accelerationZ;  // deg/s
    float gyroscopeX,    gyroscopeY,    gyroscopeZ;     // g
    float temperature;                                  // C
};

class Ulm_LSM6SDL : LSM6DSL, public Ulm_GenericSensor<Ulm_LSM6SDL_Sample> {

private:
    uint8_t i2cAddress;

public:
    explicit Ulm_LSM6SDL(uint8_t address);
    bool begin() override;
    bool sample(Ulm_LSM6SDL_Sample &t) override;
};


#endif //ULM_WEATHERBALLOON_ULM_LSM6SDL_H
