//
// Created by Falko Alrik Schmidt on 26.09.23.
//

#include "Ulm_MS5611.h"

Ulm_MS5611::Ulm_MS5611(int8_t address) : MS5611(address) {
}

bool Ulm_MS5611::begin() {
    if(!MS5611::begin()) {
        return false;
    }
    MS5611::reset(1);
    MS5611::setOversampling(OSR_ULTRA_HIGH);
    return true;
}

bool Ulm_MS5611::sample(Ulm_MS5611_Sample &sample) {
    if(MS5611::read() != MS5611_READ_OK) {
        return false;
    }

    sample.temperature = MS5611::getTemperature();
    sample.pressure = MS5611::getPressure();
    return true;
}
