//
// Created by Falko Alrik Schmidt on 11.01.24.
//

#ifndef ULM_WEATHERBALLOON_ULM_SCD40_H
#define ULM_WEATHERBALLOON_ULM_SCD40_H


#include "SensirionI2CScd4x.h"
#include "Ulm_GenericSensor.h"

struct Ulm_SCD40_Sample {
    uint16_t co2;
    float temperature;
    float humidity;
};


class Ulm_SCD40 : SensirionI2CScd4x, public Ulm_GenericSensor<Ulm_SCD40_Sample> {

public:
    /**
      * Default constructor.
      */
    Ulm_SCD40();

    /**
     * Initializes the sensor.
     * @return {@code true} on success, {@code false} otherwise.
     */
    bool begin() override;

    bool sample(Ulm_SCD40_Sample &t) override;

};

// This implementation also works with SCD41.
typedef struct Ulm_SCD40_Sample Ulm_SCD41_Sample;
typedef Ulm_SCD40 Ulm_SCD41;

#endif //ULM_WEATHERBALLOON_ULM_SCD40_H
